<template>
  <div class="airportInfo scroll-y">
    <div class="wrap">
      <Minheader
        :is-auth="true"
        :is-statuser="true"
        powerData="new_data_structure_button"
        @addForm="addForm"
      >
        <template #header>
          <div class="status flex-wrap">
            <div class="manageTitle">数据结构</div>
          </div>
        </template></Minheader
      >
      <div class="app-containers">
        <DataTable
          :tableHeader="tableCols"
          :tableData="tableData"
          :tableBtnGroup="tableBtnGroup"
          :tableProperty="{ rowKey: 'ID' }"
          @btnClick="btnClick"
        />
      </div>
      <Dialog
        width="600px"
        :flag="flag"
        :type="type"
        :msgTitle="msgTitle"
        @resetForm="resetForm"
        @delRest="delRest"
        @submitForm="submitForm"
        @delRemove="delRemove"
      >
        <div class="diacont">
          <el-form
            :model="tableForm"
            :rules="formRules"
            ref="datastructureForm"
          >
            <el-row :gutter="24">
              <el-col>
                <el-form-item
                  label="结构名称"
                  size="default"
                  prop="structureName"
                  :rules="formRules.isNotNull"
                >
                  <el-input
                    v-model="tableForm.structureName"
                    placeholder="请输入结构名称"
                  />
                </el-form-item>
              </el-col>
              <el-col>
                <el-form-item label="数据格式" size="default">
                  <el-select
                    style="width: 100%"
                    v-model="tableForm.datatype"
                    class="input-shadow"
                    filterable
                    default-first-option
                    clearable
                    placeholder="请选择"
                  >
                    <el-option
                      v-for="item in tableOptionser"
                      :key="item.v ? item.v : item.planDepartureApt"
                      :label="item.k ? item.k : item.planDepartureApt"
                      :value="item.v ? item.v : item.planDepartureApt"
                    >
                    </el-option>
                  </el-select>
                </el-form-item>
              </el-col>
              <el-col>
                <el-form-item
                  label="事件标识"
                  size="default"
                  prop="eventID"
                  :rules="formRules.isNotNull"
                >
                  <el-input
                    v-model="tableForm.eventID"
                    placeholder="请输入事件标识"
                  />
                </el-form-item>
              </el-col>
              <el-col>
                <el-form-item label="描述" size="default">
                  <el-input
                    type="textarea"
                    v-model="tableForm.dataDescribe"
                    placeholder="请输入备注"
                  />
                </el-form-item>
              </el-col>
            </el-row>
          </el-form>
        </div>
      </Dialog>
    </div>
  </div>
</template>
<script setup lang="ts">
import DataTable from "@/components/tableTemp/index.vue";
import Minheader from "@/components/minheader/index.vue";
import Dialog from "@/components/dialog/index.vue";
import { Query, GeneralDataReception } from "@/api/webApi";
import { ElMessage } from "element-plus";
const formRules = useElement().formRules;
const page = ref<number>(0); //分页参数
const dataContent = ref<object>({});
const noMore = ref<Boolean>(false);
const rowTitle = ref<String>("");
const tableCols = ref([]); //表头数据
const serviceId = ref<String>("");
const tableObj = ref({}); //增删改数据缓存
const router = useRouter();
const flag = ref<Boolean>(false); //弹窗开关
const type = ref<String>(""); //判断是否删除
const msgTitle = ref<String>("新增数据结构"); //弹窗标题
const tableColsCopys = reactive<Object>({}); //弹窗\
const tableOptionser = ref([]); //弹窗下拉
const tableOptionCopys = ref([]); //弹窗下拉
const tableForm = reactive({
  dataStructureID: "",
  structureName: "",
  datatype: "",
  eventID: "",
  dataDescribe: "",
  event: "",
}); //弹窗内容
//列表
const tableData = ref([]);
//表头
const state = reactive({
  list: [
    { label: "结构名称", key: "name" },
    { label: "数据格式", key: "china" },
    { label: "事件标识", key: "englin" },
    { label: "描述", key: "two" },
  ],
  listLoading: true,
});
const tableBtnGroup = ref([
  {
    name: "编辑",
    className: "editBtn",
    param: 2,
    is: "data_structure_editing_button",
  },
  {
    name: "数据项",
    className: "editBtn",
    param: 4,
    is: "data_item_editing_page",
  },
  {
    name: "删除",
    className: "delBtn",
    param: 3,
    is: "data_structure_deletion_button",
  },
]);
//新增
const addForm = () => {
  msgTitle.value = "新增数据结构";
  flag.value = true;
  type.value = "";
  tableForm.event = 1;
};
//取消
const resetForm = () => {
  flag.value = false;
  tableForm.dataStructureID = "";
  tableForm.structureName = "";
  tableForm.datatype = "";
  tableForm.eventID = "";
  tableForm.dataDescribe = "";
};
//编辑
// const editDialog = (data) => {
//   msgTitle.value = "编辑航司信息维护";
//   flag.value = true;
//   type.value = "";
//   tableForm.name = data.name;
//   tableForm.china = data.china;
//   tableForm.englin = data.englin;
//   tableForm.two = data.two;
//   tableForm.three = data.three;
//   tableForm.text = data.text;
// };
//编辑-删除
const btnClick = (row, index, param) => {
  if (param === 2) {
    msgTitle.value = "编辑数据结构";
    flag.value = true;
    type.value = "";
    tableForm.event = 2;
    tableForm.dataStructureID = index.dataStructureID;
    tableForm.structureName = index.structureName;
    tableForm.datatype = index.datatype;
    tableForm.eventID = index.eventID;
    tableForm.dataDescribe = index.dataDescribe;
  } else if (param === 3) {
    msgTitle.value = "删除数据结构";
    flag.value = true;
    type.value = "del";
    tableForm.event = 3;
    tableForm.dataStructureID = index.dataStructureID;
    tableForm.structureName = index.structureName;
    tableForm.datatype = index.datatype;
    tableForm.eventID = index.eventID;
    tableForm.dataDescribe = index.dataDescribe;
  } else if (param === 4) {
    router.push({
      path: "/systemSettings/datastructureTerm",
      query: {
        dataStructureID: index.dataStructureID,
      },
    });
  }
};
//删除
const eleDialog = () => {
  msgTitle.value = "删除数据结构";
  flag.value = true;
  type.value = "del";
};
const delRemove = () => {
  tableForm.event = 3;
  generalDataReception(tableForm);
};
//删除
const delRest = () => {
  flag.value = false;
};
//获取弹框-下拉数据
const getSelectData = async (id, name) => {
  const { code, returnData } = await Query({
    id,
    dataContent: name ? [name] : name === null ? [null] : [],
  });
  if (code == 0) {
    tableOptionser.value = returnData.listValues;
  } else {
    tableOptionser.value = [];
  }
};
//获取表格数据
const getQuery = async () => {
  try {
    const { code, returnData } = await Query({
      id: DATACONTENT_ID.structureTabId,
      needPage: ++page.value,
      dataContent: Object.values(dataContent.value),
    });
    if (code === "0") {
      if (returnData.listValues.length === 0) {
        page.value--;
        noMore.value = true;
      }
      const titleColumn = returnData.columnSet.find(
        (item) => item.needShow === 1
      );
      if (titleColumn) {
        rowTitle.value = titleColumn.columnName;
      }
      tableData.value.push(...returnData.listValues);
      tableCols.value = returnData.columnSet;
      returnData.columnSet.forEach((item) => {
        if (item.listqueryTemplateID && item.columnName === "datatype") {
          getSelectData(item.listqueryTemplateID);
        }
      });
      tableCols.value.forEach((element) => {
        element.label = element.columnLabel;
        element.key = element.columnName;
        // if (element.columnName === "queryTemplate") {
        //   element.width = "300px";
        // }
      });
      serviceId.value = returnData.submitID;
    } else {
      page.value--;
    }
  } catch (error) {
    page.value--;
  }
};
//确认提交
const datastructureForm: any = ref(null);
const submitForm = () => {
  datastructureForm.value.validate((valid: any) => {
    if (valid) {
      generalDataReception(tableForm);
    } else {
      return false;
    }
  });
};
const resetTable = () => {
  page.value = 0;
  noMore.value = false;
  tableData.value = [];
};
//新增-编辑-删除
const generalDataReception = async (data) => {
  try {
    data = {
      ...data,
    };
    const { code } = await GeneralDataReception({
      serviceId: serviceId.value,
      dataContent: JSON.stringify(data),
    });
    if (code == 0) {
      ElMessage.success(`操作成功`);
      // this.$message.success("操作成功");
      resetTable();
      getQuery();
      resetForm();
      flag.value = false;
      // rmFlag.value = false;
      tableObj.value = {};
      // this.$router.go(0);
    } else {
      ElMessage.error(`操作失败`);
      // this.$message.error("操作失败");
      // this.flag = false;
      // this.rmFlag = false;
      tableObj.value = {};
      resetForm();
    }
  } catch (error) {
    flag.value = false;
    //  rmFlag.value = false;
    tableObj.value = {};
    resetForm();
  }
};
getQuery();
</script>
<style lang="scss" scoped>
::v-deep .el-form-item__label {
  width: 90px;
}
</style>
